/*************************************************  Filter Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2017, Red Rapids, Inc.

*************************************************  Filter Functions Header  **************************************************/

#ifndef _FILTER_FUNCTIONS_H_
#define _FILTER_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

#define FilterTypes 3
extern size_t Filter[FilterTypes][6];

// Prototypes for each of the filter functions.
unsigned long FilterConfigure(s_Adapter *p_HW, unsigned long ChannelNumber, unsigned long long Select, char *p_File);
void FilterFilename(s_Adapter *p_HW, unsigned long ChannelNumber, unsigned long long Select, char *p_File);
unsigned long FilterKeyword(char *Keyword);
unsigned long FilterParser(size_t Type, unsigned long long *Coefficients, size_t *p_Log2Gain, size_t *p_Resample, char *p_File);
size_t GetFilterCount(s_Adapter *p_HW, unsigned long ChannelNumber);
size_t GetFilterType(s_Adapter *p_HW, unsigned long ChannelNumber, unsigned long long Select);
unsigned long LoadFilterCoefficients(s_Adapter *p_HW, unsigned long ChannelNumber, unsigned long long Select, size_t Type, unsigned long long *Coefficients);
unsigned long LoadFilterGain(s_Adapter *p_HW, unsigned long ChannelNumber, unsigned long long Select, size_t Type, size_t Log2Gain);
unsigned long LoadFilterResampler(s_Adapter *p_HW, unsigned long ChannelNumber, unsigned long long Select, size_t Type, size_t Resample);

#ifdef __cplusplus
}
#endif

#endif
